#                                                         -*- Perl -*-
# Copyright (C) 2000  Satoru Takabayashi
# Copyright (C) 2000  Kazuhiko Shiozaki
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
use FileHandle;

# temp.bmp $B$r(B temp.img $B$KJQ49$9$k%W%m%0%i%`!#(B
# $B4D6-$K$"$o$;$F=$@5$7$F$/$@$5$$!#(B
# for PNG
# my $convert_program = 'convert temp.bmp PNG:temp.img';
# for PNG with pngcrush
my $convert_program = 'convert temp.bmp PNG:temp.img. && pngcrush -q temp.img. temp.img && rm temp.img.';

my $source_directory = shift;

my $main_file_name = exist_check('DATA/main.txt');
my $handle = FileHandle->new();
if (!$handle->open("$main_file_name", 'r')) {
  die "failed to open the file: $main_file_name\n";
}
# $B%S%C%HH?E>$7$?2~9T%3!<%I(B (\x100-\x0a) $B$G9T$KJ,$1$k!#(B
$/ = "\xf5";
binmode $handle;

my $img_file_name = exist_check('DATA/img.dat');
my $handle_in = FileHandle->new();
if (!$handle_in->open("$img_file_name", 'r')) {
  die "failed to open the file: $img_file_name\n";
}
binmode $handle_in;

my %count = ();
my $new_offset = 0;
my $loop = 1;
while (1) {
  $_ = ~ $handle->getline;
  last if !$_;
  if (/^IMG=([0-9A-F]{8}),([0-9A-F]{8})$/) {
    my $offset_hex = $1;
    my $length_hex = $2;

    # $B=EJ#$7$?8+=P$78l$N=hM}(B
    next if (defined $count{$offset_hex});

    $count{$offset_hex}=1;
    print STDERR "$loop: $offset_hex $length_hex\n";
    $loop++;
    my $offset = hex $offset_hex;
    my $length = hex $length_hex;
    my $handle_out = FileHandle->new();
    if (!$handle_out->open("temp.bmp", 'w')) {
      die "failed to open the file: temp.bmp\n";
    }
    binmode $handle_out;
    seek($handle_in, $offset, 0) || die "Seek Error\n";
    read $handle_in, my $content, $length || die "Read Error\n";
    print $handle_out $content || die "Write Error\n";
    $handle_out->close();
    system $convert_program;
    system "cat temp.img >> img.dat";
    my $new_length = -s 'temp.img';
    printf("%s %s %08x %08x\n", $offset_hex, $length_hex,
	   $new_offset, $new_length);
    $new_offset += $new_length;
  }
}

#
# $B%U%!%$%k$,$"$k$+3NG'$9$k(B
# $BA4BgJ8;z$dA4>.J8;z$b3NG'$7!"B8:_$7$?%U%!%$%kL>$rJV$9!#(B
#
sub exist_check {
  my($in) = $_[0];
  my($out) = $in;
  return "$source_directory/$out" if -f "$source_directory/$out";
  $out = lc($out);
  return "$source_directory/$out" if -f "$source_directory/$out";
  $out = uc($out);
  return "$source_directory/$out" if -f "$source_directory/$out";
  die "file not found: $in\n"
}
